;
; les procdures
;
.DATA
ALIGN 16
;
; ici, ce sont les tmoins concernant les informations du microprocesseur
;
_Temoins_Aptitudes_Du_MicroProcesseur_	DWORD ?
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
; bit 12 =

;_Temoin_Type_Du_MicroProcesseur_		DWORD ?
;
;
;
;
;


.CODE
ALIGN 16
;
; obtenir des informations sur le microprocesseur qui utilise le programme
;
; Syntaxe :
; call DefinirAptitudesDuProcesseur
;
; Retourne :
; eax et la variable _Temoins_Aptitudes_Du_MicroProcesseur_ sont dfinis avec les bits positionns
;
DefinirAptitudesDuProcesseur PROC
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi

		xor esi,esi									;; mettre esi (le registre qui stockera les bits)  0
; l'instruction CPUID est supporte, seulement s'il est possible de positionner/enlever le flag ID (EFLAGS bit 21).
		pushfd										;; ) copier les flags+flags etendus dans eax et edx
		pop eax										;; )
		mov edx,eax									;; )
		btc eax,21									;; inverser le flag ID (bit 21)
		push eax										;; ) et recopier le rsultat dans les flags
		popfd										;; )
		pushfd										;;	) puis on recopie  nouveau les flags dans eax
		pop eax										;;	)
		cmp eax,edx									;; comparer le rsultat  notre prcdente sauvegarde
		je PasSupportCpuid								;; si c'est semblable, c'est que notre modif n'a eu aucun effet, alors aller PasSupportCpuid
		bts esi,0										;; positionner le bit correspondant dans esi

; ici, l'instruction cpuid est supporte, on va donc s'en servir pour connaitre les aptitudes du processeur
;		mov eax,0										;; ici, on dtermine le type d'infos que l'on veut rcuprer
;		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
;													;; (eax contient le nombre d'entres cpuid maximales)

; ici, on passe aux informations suivantes
		mov eax,1										;; ici, on dtermine les infos les plus importantes (du moins pour la programmation)
		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
													;; (eax contient le type, le model,la famille,...)
													;; (edx contient les caractristiques disponibles)
; les instructions fpu sont disponibles ?
		bt edx,0										;; tester le bit 0
		jnc PasSupportFpu								;; si le flag carry n'est pas positionn, aller PasSupportFpu
		bts esi,1										;; positionner le bit correspondant dans esi
PasSupportFpu:
; l'instruction rdtsc est disponible ?
		bt edx,4										;; tester le bit 4
		jnc PasSupportRdtsc								;; si le flag carry n'est pas positionn, aller PasSupportRdtsc
		bts esi,2										;; positionner le bit correspondant dans esi
PasSupportRdtsc:
; l'instruction CmpXchg8b est disponible ?
		bt edx,8										;; tester le bit 8
		jnc PasSupportCmpXchg8b							;; si le flag carry n'est pas positionn, aller PasSupportCmpXchg8b
		bts esi,3										;; positionner le bit correspondant dans esi
PasSupportCmpXchg8b:
; les instructions cmov sont disponibles ?
		bt edx,15										;; tester le bit 15
		jnc PasSupportCmov								;; si le flag carry n'est pas positionn, aller PasSupportCmov
		bts esi,4										;; positionner le bit correspondant dans esi
PasSupportCmov:
; les instructions clfsh sont disponibles ?
		bt edx,19										;; tester le bit 19
		jnc PasSupportClfsh								;; si le flag carry n'est pas positionn, aller PasSupportClfsh
		bts esi,5										;; positionner le bit correspondant dans esi
PasSupportClfsh:
; les instructions mmx sont disponibles ?
		bt edx,23										;; tester le bit 23
		jnc PasSupportMmx								;; si le flag carry n'est pas positionn, aller PasSupportMmx
		bts esi,6										;; positionner le bit correspondant dans esi
PasSupportMmx:
; les instructions fxsr sont disponibles ?
		bt edx,24										;; tester le bit 24
		jnc PasSupportFxsr								;; si le flag carry n'est pas positionn, aller PasSupportFxsr
		bts esi,7										;; positionner le bit correspondant dans esi
PasSupportFxsr:
; les instructions sse sont disponibles ?
		bt edx,25										;; tester le bit 25
		jnc PasSupportSse								;; si le flag carry n'est pas positionn, aller PasSupportSse
		bts esi,8										;; positionner le bit correspondant dans esi
PasSupportSse:
; les instructions sse2 sont disponibles ?
		bt edx,26										;; tester le bit 26
		jnc PasSupportSse2								;; si le flag carry n'est pas positionn, aller PasSupportSse2
		bts esi,9										;; positionner le bit correspondant dans esi
PasSupportSse2:
; les instructions htt sont disponibles ?
		bt edx,28										;; tester le bit 28
		jnc PasSupportHtt								;; si le flag carry n'est pas positionn, aller PasSupportHtt
		bts esi,10									;; positionner le bit correspondant dans esi
PasSupportHtt:
; les instructions sse3 sont disponibles ?
		bt ecx,0										;; tester le bit 0
		jnc PasSupportSse3								;; si le flag carry n'est pas positionn, aller PasSupportSse3
		bts esi,11									;; positionner le bit correspondant dans esi
PasSupportSse3:
;; les instructions Xxx sont disponibles ?
;		bt edx,Xxx									;; tester le bit 
;		jnc PasSupportXxx								;; si le flag carry n'est pas positionn, aller
;		bts esi,x										;; positionner le bit correspondant dans esi
;PasSupportXxx:

; ici, on passe aux informations suivantes
;		mov eax,2										;; ici, on dtermine les infos concernant le cache
;		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
PasSupportCpuid:
		mov _Temoins_Aptitudes_Du_MicroProcesseur_,esi		;; sauvegarder les tmoins dans notre variable
		mov eax,esi									;; et les recopier dans eax

		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
	ret												;; retourner, sortir de la procdure
DefinirAptitudesDuProcesseur ENDP


ALIGN 16
;
; positionner une fentre outils  son emplacement logique
;
; Syntaxe :
; mov esi,{pointeur de la fentre}
; mov edi,{OFFSET (adresse) de la structure RECT utilise}
; call PositionnerFenetreOutil
;
; Retourne :
; eax = 0 si erreur
;
; Syntaxe : PositionnerFenetreOutil
;
PositionnerFenetreOutil PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

; positionner la fentre sur la droite de notre cran (en la centrant en hauteur)
		invoke GetWindowRect,esi,edi						;; obtenir les coordonnes de la boite de dialogue
		mov eax,(RECT PTR [edi]).left						;; ) calculer la largeur et la placer dans (RECT PTR [edi]).right
		sub (RECT PTR [edi]).right,eax					;; )
		mov eax,(RECT PTR [edi]).top						;;	) calculer la hauteur et la placer dans (RECT PTR [edi]).bottom
		sub (RECT PTR [edi]).bottom,eax					;;	)
		invoke GetSystemMetrics,SM_CXSCREEN				;; obtenir la taille x de l'ecran os (en pixels)
		sub eax,(RECT PTR [edi]).right					;; soustraire la largeur de notre ecran final
		mov (RECT PTR [edi]).left,eax						;; placer la nouvelle position x
		add (RECT PTR [edi]).right,eax					;; et ajouter la position x  la taille x
		invoke GetSystemMetrics,SM_CYSCREEN				;; obtenir la taille y de l'ecran os (en pixels)
		sub eax,(RECT PTR [edi]).bottom					;; soustraire la largeur de notre ecran final
		sar eax,1										;; pour centrer verticalement
		mov (RECT PTR [edi]).top,eax						;; placer la nouvelle position Y
		add (RECT PTR [edi]).bottom,eax					;; et ajouter la position y  la taille y
		invoke GetSystemMetrics,SM_CXVSCROLL				;; ) enlever la largeur d'une barre de scrolling verticale
		sub (RECT PTR [edi]).left,eax						;; )
		sub (RECT PTR [edi]).right,eax					;; )
		invoke GetSystemMetrics,SM_CXBORDER				;; ) (ici, avec les bordures)
		add eax,eax									;; plus rapide que :
;		shl eax,1										;; 
		sub (RECT PTR [edi]).left,eax						;; )
		sub (RECT PTR [edi]).right,eax					;; )
		invoke SetWindowPos,esi,NULL,(RECT PTR [edi]).left,(RECT PTR [edi]).top,NULL,NULL,SWP_NOSIZE or SWP_NOZORDER

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner, sortir de la procdure
PositionnerFenetreOutil ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de gnration de nombres alatoires
; *
; * note : ici je n'ai pas utilis les valeurs que j'utilise habituellement, parcequ'elles font partie de ma
; * signature (et vous ne voudriez pas vous retrouver avec un procs sur le dos, non ?) alors j'en ai mis d'autres
; * qui devrait fonctionner...
; * si ce n'est pas le cas changez les... le systme employ permet un grand ventail de possibilits
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Nombres_Aleatoires_		DWORD ?


.CODE
ALIGN 16
;
; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.
;
; Rceptionne :
; rien
;
; Retourne:
; eax = nombre de tick depuis le dmarrage de l'ordi. (mais surtout, la variable _Nombres_Aleatoires_ est dfinie)
;
; syntaxe : InitialiserNombresAleatoires
;
InitialiserNombresAleatoires PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke GetTickCount								;; obtenir les millisecondes depuis le dmarrage
		test eax,eax									;; tester si eax = 0 (si c'est possible ! si vous lancez ce programme 48 jours aprs le dmarrage de l'ordinateur, lol)
		jnz Label1									;; si diffrent aller Label 1
		mov eax,123456789								;; mettre un nombre quelconque (pour eviter une division ultrieure par 0, suivant le gnrateur utilis)
Label1:	mov _Nombres_Aleatoires_,eax						;; sauver le rsultat pour initialiser les nombres alatoires

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
InitialiserNombresAleatoires ENDP


ALIGN 16
;
; generer un nombre aleatoire 32-bits entre 0 et une valeur maximale (exclue)
;
; Rceptionne :
; ebx = la valeur maximale +1 (ne peut pas tre zro, doit imprativement tre suprieur  1 pour une valeur
; situe dans un rang, ou 1 pour gnrer une valeur alatoire 32 bits)
;
; Retourne :
; eax = nombre aleatoire entre 0 et la valeur maximale (exclue), ou un nombre alatoire 32 bits si ebx = 1
;
; syntaxe : GenererNombreAleatoire
;
GenererNombreAleatoire PROC
		push edx										;; empiler edx

		mov eax,987654321								;; placer 987654321 dans eax
		mul _Nombres_Aleatoires_							;; multiplier eax par l'alatoire prcedent
		bswap eax										;; inverser l'ordre des octets pour rendre la valeur plus alatoire
		xor eax,078787878h								;; et pratiquer une inversion de bits (ne peut tre fait avec 0h ou FFFFFFFFh)
		jnz Label1									;; si c'est diffrent de 0, aller Label1
		mov eax,123456789								;; sinon, placer 123456789 dans eax
Label1:	mov _Nombres_Aleatoires_,eax						;; sauvegarder le nouveau nombre alatoire pour la gnration du prochain
; ici, on teste si c'est le cas d'une valeur alatoire 32 bits 
		cmp ebx,1										;; comparer ebx  1
		je Label2										;; si c'est le cas, c'est une valeur alatoire 32 bits, alors aller Label2
; ici, on traite le cas d'une valeur comprise entre 0 et X-1
		mul ebx										;; multiplier ensuite le nombre alatoire par la valeur maximale
		mov eax,edx									;; et placer le dpassement en eax
Label2:
		pop edx										;; dsempiler edx
	ret												;; retourner (sortir de la procdure)
GenererNombreAleatoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines d'optimisation
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_O_Valeur_Nombre_Magique_	QWORD ?		;; ) variable qui recevra le nombre magique
_O_Valeur_Diviseur_			QWORD ?		;; ) variable qui recevra le diviseur


.CODE
ALIGN 16
;
; obtenir un multiplicateur magique (substituer une multiplication  une lente division) methode 1
; multiplicateur magique = (valeur maximale du registre / diviseur) + 1
;
; cette methode permet d'obtenir des multiplicateurs "magiques" plus rapides, mais ceux-ci manquent de prcision
; (arrondis) lorsqu'au moins une des valeurs est leve. c'est test et vrifi sans erreurs lorsque la valeur 
; diviser va de 0  65536, et que le diviseur va de de 2  65536 (0 et 1, doivent videment tre traits autrement).
;
; Syntaxe :
; mov ebx,{diviseur}
; call ObtenirMultiplicateurMagique
;
; Retourne :
; eax = le multiplicateur "magique"
;
ObtenirMultiplicateurMagique PROC
		push edx										;; empiler edx

		mov eax,0FFFFFFFFh								;; remplir le registre eax
		xor edx,edx									;; effacer edx pour la division qui suit
		div ebx										;; diviser eax par le diviseur
		inc eax										;; augmenter le rsultat obtenu de 1 (pour faire passer virtuellement FFFFFFFF  100000000)

		pop edx										;; dsempiler edx
	ret												;; retourner (sortir de la procdure)
ObtenirMultiplicateurMagique ENDP


ALIGN 16
;
; obtenir un multiplicateur magique (substituer une multiplication  une lente division) methode 2
;
; dvelopp par THE SVIN, en gros c'est idem  la methode 1, sauf qu'un dcalage est pratiqu au pralable sur la
; valeur  diviser, et qu'un dcalage est ensuite pratiqu sur le rsultat (ce qui est un peu plus lent, mais ca
; augmente beaucoup la prcision du rsultat obtenu)
;
; Syntaxe :
; mov ebx,{diviseur}
; call ObtenirMultiplicateurMagiquePrecis
;
; Retourne :
; eax = le multiplicateur "magique"
; ecx = le dcalage qu'il faudra pratiquer
; edx = 0 ou 1 en fonction de l'algo  utiliser (0 = sans inc, 1 = avec inc)
;
ObtenirMultiplicateurMagiquePrecis PROC
		push esi										;; empiler esi

		bsr ecx,ebx									;; trouver le premier bit positionn du diviseur, en commencant par le bit 31
		mov esi,OFFSET _O_Valeur_Nombre_Magique_			;; placer l'adresse du qword qui recevra le multiplicateur dans esi
		xor edx,edx									;; sinon, effacer edx
		mov [esi],edx									;; placer 00000000, xxxxxxxx dans _O_Valeur_Nombre_Magique_
		mov [esi+12],edx								;; placer xxxxxxxx, 00000000 dans _O_Valeur_Diviseur_
		inc edx										;; placer 00000001 dans edx
		mov [esi+8],ebx								;; placer Diviseur, 00000000 dans _O_Valeur_Diviseur_
		shl edx,cl									;; dcaler edx sur la gauche, avec la valeur en ecx
		mov [esi+4],edx								;; placer 00000000, 0000<--1 dans _O_Valeur_Nombre_Magique_

		fild QWORD PTR [esi]							;; charger l'entier 00000000, 0000<--1 dans st(1) (2^(b+32))
		fild QWORD PTR [esi+8]							;; charger l'entier Diviseur, 00000000 dans st(0)
		fdivp st(1),st(0)								;; diviser st(1) par st(0) et dsempiler st(0), le rsultat obtenu en st(1) se retrouve donc en st(0)
		fst st(1)										;; copier le rsultat obtenu en st(0) dans st(1)
		fistp QWORD PTR [esi]							;; sauvegarder l'entier dans _O_Valeur_Nombre_Magique_, et dsempiler st(0) (st(1) se retrouve donc en st(0))
		fild QWORD PTR [esi]							;; recharger l'entier dans st(0) (l'ancien st(0) se retrouve donc  nouveau en st(1))
		fcompp										;; comparer st(0) et st(1) (pour voir s'il n'y a pas de perte lors de la transformation en entier) et dsempiler ces 2 registres fpu
		fstsw ax										;; rcuprer le rsultat de la comparaison du statut word

		xor edx,edx									;; nettoyer edx
		sahf											;; copier le rsultat dans les flags
		ja EviterIncrementer							;; si c'est suprieur, aller EviterIncrementer
		inc edx										;; incrmenter edx
EviterIncrementer:
		mov eax,DWORD PTR [esi]							;; placer _O_Valeur_Nombre_Magique_ dans eax

		pop esi										;; dsempiler esi
	ret												;; retourner (sortir de la procdure)
ObtenirMultiplicateurMagiquePrecis ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de traitement/gestion de bloc mmoire
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


ALIGN 16
;
; allouer un bloc mmoire  un pointeur (ce bloc est align sur 16 octets)
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
;
; Rceptionne :
; eax = taille du bloc mmoire que l'on va crer (en octets)
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_
;
; retourne :
; eax = adresse du bloc mmoire alig
; et les variables x._Pointeur_, x._Pointeur_A_Liberer_ et x._Taille_Du_Bloc_ sont dfinies
;
; syntaxe : AllouerBlocMemoire
;
AllouerBlocMemoire PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax		;; placer eax dans x._Taille_Du_Bloc_
		add eax,000000010h								;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax		;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax		;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax		;; sauvegarder eax dans x._Pointeur_

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
AllouerBlocMemoire ENDP


ALIGN 16
;
; crer l'instance mmoire (ce qui doit tre fait, une fois, avant de pouvoir allouer des blocs mmoires)
; note : normalement (sauf cas exceptionnels) une seule instance suffit pour l'ensemble de votre programme
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
;
; retourne :
; eax = l'adresse de l'instance
; et les variables x._Instance_, x._Taille_Initiale_ et x._Taille_Maximale_ sont dfinies
;
; syntaxe : CreerInstanceMemoire
;
CreerInstanceMemoire PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapCreate,HEAP_NO_SERIALIZE,(_Informations_Memoire_ PTR [esi])._Taille_Initiale_,(_Informations_Memoire_ PTR [esi])._Taille_Maximale_		;; cr une instance mmoire, et defini des valeurs mmoire
		mov (_Informations_Memoire_ PTR [esi])._Instance_,eax		;; sauvegarde du pointeur de l'instance

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
CreerInstanceMemoire ENDP


ALIGN 16
;
; librer un bloc mmoire
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_
;
; retourne :
; rien
;
; syntaxe : LibererBlocMemoire
;
LibererBlocMemoire PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_		;; librer le bloc mmoire correspondant au pointeur

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
LibererBlocMemoire ENDP


ALIGN 16
;
; supprimer l'instance mmoire (ce qui doit tre fait avant de sortir de l'application, si une instance  t cre)
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
;
; retourne :
; rien
;
; syntaxe : SupprimerInstanceMemoire
;
SupprimerInstanceMemoire PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapDestroy,(_Informations_Memoire_ PTR [esi])._Instance_		;; librer l'instance mmoire

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
SupprimerInstanceMemoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines traitement de chaines de caractre
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_TCA_Pointeur_Fenetre_Selectionnee_	DWORD ?
_TCA_Pointeur_Fenetre_Temporaire_		DWORD ?


.CODE
ALIGN 16
;
; transfrer une chane de caractres/un texte dans le clipboard, et pratiquer un ctrl+V dans la fentre vise
;
; Syntaxe :
; mov eax,{pointeur (handle) de la fentre slectionne}
; mov esi,{adresse (offset) de la chane  transfrer}
; call Clipboard_InjecterChaineAscii
;
; Retourne :
; eax = 0 si ok, -1 si erreur
;
Clipboard_InjecterChaineAscii PROC
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push edi										;; empiler edi

; sauvegarder ce qui servira ultrieurement
		mov _TCA_Pointeur_Fenetre_Selectionnee_,eax			;; sauvegarder le pointeur qui servira plus tard, l on a besoin de eax...
; rserver la mmoire ncessaire
;		mov esi,OFFSET									;; ) obtenir la taille relle de la chane/du texte en eax
		call ObtenirTailleChaineAscii						;; )
		inc eax										;; ajouter le zro final
		invoke GlobalAlloc,GMEM_MOVEABLE or GMEM_DDESHARE or GMEM_ZEROINIT,eax		;; allouer la taille obtenue
		test eax,eax									;; ) test d'existence du bloc, sinon sortir
		jz FinInsertionClipboard							;; )
		mov ebx,eax									;; sauvegarder le pointeur obtenu
		invoke GlobalLock,eax							;; obtenir l'adresse de dpart du bloc
;		mov esi,OFFSET									;; ) recopier la chane dans le bloc cr
		mov edi,eax									;; )
		call CopierChaineAscii							;; )
		invoke GlobalUnlock,ebx							;; ici, pas besoin de rajouter quoi que ce soit...
; transfrer le bloc cr dans le tampon du clipboard
		invoke OpenClipboard,NULL						;; ouvrir le tampon clipboard avec notre program
		test eax,eax									;; ) test d'accessibilit valide, sinon sortir
		jz LibererMemoireClipboard						;; )
		invoke EmptyClipboard							;; vider le tampon clipboard (ben ouip...)
		test eax,eax									;; ) test confirmant que le tampon est bien vid, sinon sortir
		jz FermerClipboard								;; )
		invoke SetClipboardData,CF_TEXT,ebx				;; dfinir le format des donnes, et les donnes
; sortie normale
		invoke CloseClipboard							;; fermer le tampon clipboard (pour qu'il devienne accessible aux autres applications)
		invoke GlobalFree,ebx							;; librer la mmoire devenue inutile

;		invoke GetWindow,_TCA_Pointeur_Fenetre_Selectionnee_,GW_OWNER		;; ) test d'existence de la fenetre cible
;		test eax,eax									;; ) (marche pas...  zieuter...)
;		jz FinEnvoiTouches								;; )

; faire pratiquer un ctrl+v par la fentre slectionne
		invoke GetForegroundWindow						;; ) sauvegarder le pointeur de notre application (puisqu'elle est devant normalement)
		mov _TCA_Pointeur_Fenetre_Temporaire_,eax			;; )

		invoke SetForegroundWindow,_TCA_Pointeur_Fenetre_Selectionnee_		;; activer la fentre de rception (pour que le clipboard soit accessible par elle)
; et envoyer l'entre clavier
		invoke keybd_event,VK_CONTROL,NULL,NULL,NULL			;; envoyer touche "ctrl" presse
		invoke Sleep,10								;; attendre un peu
		invoke keybd_event,VK_V,NULL,NULL,NULL				;; envoyer touche "V" presse
		invoke Sleep,10								;; attendre un peu
		invoke keybd_event,VK_V,NULL,KEYEVENTF_KEYUP,NULL		;; envoyer touche "V" relache
		invoke Sleep,10								;; attendre un peu
		invoke keybd_event,VK_CONTROL,NULL,KEYEVENTF_KEYUP,NULL		;; envoyer touche "ctrl" relache
		invoke SetForegroundWindow,_TCA_Pointeur_Fenetre_Temporaire_		;; replacer notre application sur le devant (pour pouvoir  nouveau utiliser le clipboard)

; normalement, ici le clipboard a t ouvert par la fentre cible, on va donc le refermer...
		invoke OpenClipboard,NULL						;; ouvrir le tampon clipboard (pour redemander la main)
		test eax,eax									;; ) test d'accessibilit valide, sinon sortir
		jz FinEnvoiTouches								;; )
		invoke EmptyClipboard							;; vider le tampon clipboard
		invoke CloseClipboard							;; fermer le tampon clipboard (pour qu'il redevienne accessible a notre programme)

FinEnvoiTouches:
		pop edi										;; dsempiler edi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
		xor eax,eax									;; effacer eax (tout est ok)
	ret												;; retourner

; sortie si problme
FermerClipboard:
		invoke CloseClipboard							;; fermer le tampon clipboard (pour qu'il devienne accessible aux autres applications)
LibererMemoireClipboard:
		invoke GlobalFree,ebx							;; librer la mmoire devenue inutile
FinInsertionClipboard:
		pop edi										;; dsempiler edi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
		mov eax,-1									;; placer -1 (erreur) dans eax
	ret												;; retourner
Clipboard_InjecterChaineAscii ENDP


ALIGN 16
;
; convertir un motlong en texte au format dcimale (routine la plus stable) (fait jusqu'a 66 cycles)
;
; Rceptionne :
; eax = la valeur
; esi = adresse de la chaine de caractres  crer
;
; Retourne :
; rien
;
; syntaxe : ConvertirValeurEnChaineDecimale
;
ConvertirValeurEnChaineDecimale PROC
		push eax										;; empiler eax
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi

		mov ecx,eax									;; copier eax dans ecx

; on va diviser eax par 100000 de manire optimise
		mov edx,2814749768								;; placer 2814749768 (remplacement de 2814749767 et eax+1) dans edx
		mul edx										;; multiplier eax par 2814749768
		shr edx,16									;; dcaler edx de 16 bits  droite
		mov eax,100000									;; placer 100000 dans eax
		mov ebx,edx									;; copier edx dans ebx
		mul edx										;; multiplier edx par 100000
		sub ecx,eax									;; soustraire le rsultat en eax  ecx
		test ebx,ebx									;; fixer les flags de ebx
		mov edx,ebx									;; replacer ebx dans edx
		mov ebx,10									;; placer 10 (notre multiplicateur dcimale) dans ebx
		jz Label01									;; si c'est gal  0, aller Label01

; sinon, on traite la partie suprieure du nombre
		mov eax,429497									;; on remplace eax par 429497
		mul edx										;; multiplier edx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label02									;; s'il existe un dpassement, aller Label02
		mul ebx										;; multiplier eax par 10
		jc Label03									;; s'il existe un dpassement, aller Label03
		mul ebx										;; multiplier eax par 10
		jc Label04									;; s'il existe un dpassement, aller Label04
		mul ebx										;; multiplier eax par 10
		jc Label05									;; s'il existe un dpassement, aller Label05
		mul ebx										;; multiplier eax par 10
		jc Label06									;; s'il existe un dpassement, aller Label06

; ici, on traite la partie infrieure du nombre
Label01:	mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label07									;; s'il existe un dpassement, aller Label07
		mul ebx										;; multiplier eax par 10
		jc Label08									;; s'il existe un dpassement, aller Label08
		mul ebx										;; multiplier eax par 10
		jc Label09									;; s'il existe un dpassement, aller Label09
		mul ebx										;; multiplier eax par 10
		jc Label10									;; s'il existe un dpassement, aller Label10
		mul ebx										;; multiplier eax par 10
		jmp Label11									;; aller Label11

; maintenant on va calculer et copier chaque octets/caractres
Label02:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label03:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label04:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label05:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label06:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi

		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label07:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label08:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label09:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label10:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		inc esi										;; ajouter 1 octet  l'adresse en esi
Label11:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; placer l'octet en dl  l'adresse en esi
		mov BYTE PTR [esi+1],0							;; placer le 0 final  l'adresse en esi+1
		xor eax,eax									;; effacer eax

		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
ConvertirValeurEnChaineDecimale ENDP


ALIGN 16
;
; copier une chane de caractres dans une autre chane
; note : videment, les tailles doivent tre valides pour les chanes source et destination
;
; Rceptionne :
; esi = adresse de la chane source.
; edi = adresse dans la chane de destination
;
; Retourne :
; eax = nombre de caractres copis (c-a-d la taille de la chane)
;
; syntaxe : CopierChaineAscii
;
CopierChaineAscii PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		xor eax,eax									;; effacer eax (notre compteur d'octets)
		jmp Label2									;; aller Label2
		nop											;; ) alignement ncessaire pour un meilleur rendement
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
		nop											;; )
Label1:	add edx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],edx						;; placer cette valeur  l'adresse de destination
		add eax,4										;; incrmenter esi (l'adresse) de 4 (un dword)
Label2:	mov ecx,DWORD PTR [esi+eax]						;; placer le motlong de l'adresse actuelle dans eax
		lea edx,[ecx-01010101h]							;; placer eax (- 1  chaque octets du motlong) dans edx
		xor ecx,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and ecx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and ecx,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		add edx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de ecx
		mov [edi+eax],dl								;; placer dl  l'adresse en edi+eax
		test dl,dl									;; fixer les flags de dl
		jz Label5										;; si c'est gal  0, aller Label5
		mov [edi+eax+1],dh								;; placer dh  l'adresse en edi+eax+1
		test dh,dh									;; fixer les flags de dh
		jz Label4										;; si c'est gal  0, aller Label4
		shr edx,16									;; dcaler edx  droite de 16 bits
		mov [edi+eax+2],dl								;; placer dl  l'adresse en edi+eax+2
		test dl,dl									;; fixer les flags de dl
		jz Label3										;; si c'est gal  0, aller Label3
		mov [edi+eax+3],dh								;; placer dh  l'adresse en edi+eax+3
		inc eax										;; ajouter 1  eax ) (optionnel) pour obtenir la taille de la chaine dans eax
Label3:	inc eax										;; ajouter 1  eax )
Label4:	inc eax										;; ajouter 1  eax )
Label5:
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CopierChaineAscii ENDP


ALIGN 16
;
; fusionner des chaines de caractres
;
; Rceptionne :
; edi = adresse de la chane de destination
; le nombre de chaines  ajouter (1 au minimum) (qui servira de compteur)
; et les adresses des diffrentes chanes sources que l'on ajoutera
;
; Retourne :
; eax = la taille de la nouvelle chaine obtenue
;
; syntaxe : FusionnerMultiplesChainesAscii [nombre de chaines  ajouter],[adresse de la chane source1],[adresse de la chane source2],...
;
FusionnerMultiplesChainesAscii PROC C _Compteur_:DWORD,_Adresse_Sources_:VARARG
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi
		push edi										;; empiler edi

		lea esi,_Adresse_Sources_						;; placer l'adresse de la premire chane source dans esi
		nop											;; alignement ncessaire pour un meilleur rendement

; premirement on va trouver le zro final de la chaine de destination
Label1:	mov eax,DWORD PTR [edi]							;; placer le motlong de l'adresse actuelle dans eax
		add edi,4										;; incrmenter edi (l'adresse) de 4 (un dword)
		lea edx,[eax-01010101h]							;; placer eax (- 1  chaque octets du motlong) dans edx
		xor eax,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and eax,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and eax,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		bsf edx,eax									;; sinon, scanner le premier bit arm en eax, en commencant par la droite. et placer le numro du bit en edx
		sub edx,4										;; soustraire 4 au numro du bit obtenu
		shr edx,3										;; dcaler edx  droite de 3 bits pour obtenir le nombre d'octets
		lea edi,[edi+edx-4]								;; placer edi + edx - 1 dword dans edi

; ensuite on va prparer nos copie de chaines
		xor ebx,ebx									;; effacer ebx (notre compteur de chanes)
Label2:	push ebx										;; empiler ebx (parcequ'on  plus de registres libres)
		mov ebx,[4*ebx+esi]								;; placer l'adresse de la nouvelle source dans ebx
		xor eax,eax									;; effacer eax (notre compteur d'octets)
		jmp Label4									;; aller Label4

; et on effectue nos copies
Label3:	add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],ecx						;; placer cette valeur  l'adresse de destination
		add eax,4										;; incrmenter eax (notre compteur d'octets) de 4 (un dword)
Label4:	mov edx,DWORD PTR [ebx+eax]						;; placer le motlong de l'adresse actuelle dans edx
		lea ecx,[edx-01010101h]							;; placer eax (- 1  chaque octets du motlong) dans ecx
		xor edx,ecx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans ecx comme masque
		and edx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label3										;; si le filtrage est gal  0, aller Label3
		and edx,ecx									;; ne conserver en edx que les bits positionns en ecx
		jz Label3										;; si le filtrage est gal  0, aller Label3
		add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de edx
		mov [edi+eax],cl								;; placer cl  l'adresse en edi+eax
		test cl,cl									;; fixer les flags de cl
		jz Label7										;; si c'est gal  0, aller Label7
		mov [edi+eax+1],ch								;; placer ch  l'adresse en edi+eax+1
		test ch,ch									;; fixer les flags de ch
		jz Label6										;; si c'est gal  0, aller Label6
		shr ecx,16									;; dcaler ecx  droite de 16 bits
		mov [edi+eax+2],cl								;; placer cl  l'adresse en edi+eax+2
		test cl,cl									;; fixer les flags de cl
		jz Label5										;; si c'est gal  0, aller Label5
		mov [edi+eax+3],ch								;; placer ch  l'adresse en edi+eax+3
		inc eax										;; ajouter 1  eax
Label5:	inc eax										;; ajouter 1  eax
Label6:	inc eax										;; ajouter 1  eax
Label7:	lea edi,[edi+eax]								;; ajouter eax+1  edi

; l on va tester s'il y a une autre source  ajouter
		pop ebx										;; dsempiler ebx (pour r-obtenir notre compteur de sources)
		inc ebx										;; ajouter 1 au nombre de source
		cmp ebx,_Compteur_								;; et le comparer  Compteur
		jne Label2									;; si c'est diffrent, aller Label2

; ici, on calcul la nouvelle taille de la chane...
		mov eax,edi									;; placer edi dans eax

		pop edi										;; dsempiler edi
		sub eax,edi									;; et soustraire AdresseDestination  eax pour obtenir la nouvelle taille de la chane
		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
	ret												;; retourner (sortir de la procdure)
FusionnerMultiplesChainesAscii ENDP


ALIGN 16
;
; obtenir la taille relle d'une chane de caractres
;
; Rceptionne :
; esi = adresse de la chane dont on veut obtenir la taille
;
; Retourne :
; eax = taille relle de la chane
;
; syntaxe : ObtenirTailleChaineAscii
;
ObtenirTailleChaineAscii PROC
		push edx										;; empiler edx
		push esi										;; empiler esi

		nop
Label1:	mov eax,DWORD PTR [esi]							;; placer le motlong de l'adresse actuelle dans eax
		add esi,4										;; incrmenter esi (l'adresse) de 4 (un dword)
		lea edx,[eax-01010101h]							;; placer eax (- 1  chaque octets du motlong) dans edx
		xor eax,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and eax,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and eax,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		bsf edx,eax									;; sinon, scanner le premier bit arm en eax, en commencant par la droite. et placer le numro du bit en edx
		sub edx,4										;; soustraire 4 au numro du bit obtenu
		shr edx,3										;; dcaler edx  droite de 3 bits pour obtenir le nombre d'octets
		lea eax,[esi+edx-4]								;; placer esi + edx - 1 dword dans eax

		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		sub eax,esi									;; et soustraire l'adresse originelle au rsultat obtenu
	ret												;; retourner (sortir de la procdure)
ObtenirTailleChaineAscii ENDP


